using System;
using System.IO;
using Bram.NxtSharp;
using Bram.Utilities;
using System.Threading;
using System.Windows.Forms;




namespace MaxDeRobot.Resources
{

    /*TODO:
     * action fire mechanisme (rule base shit)
     * !!!!precoded if else statement architecture <-- how? 
     * checks on END OF LINE
     * TESTING! TESTING! TESTING! TESTING! TESTING! TESTING! TESTING! TESTING!
     */

    public class Transformer
    {        
        private const string BEGINTAG = "Begin";
        private const string ENDTAG = "Einde";
        private const string EOF = "eof";
        private const string EOL = "eol";

        private NxtMotor nxtMA;
        private NxtMotor nxtMB;
        private NxtMotor nxtMC;
        private NxtBrick myBrick;
        private NxtSoundSensor nxtSndS;
        private NxtPressureSensor nxtPs;



        public int lightVal = 0;
        

        public string test = "test";

        private RobotController rc = new RobotController();
        
        string[,,] blokcodeArray;

        public string[,,] bcArray
        {
            get { return blokcodeArray; }
            set { blokcodeArray = value; }
        }

        public Transformer(string[,,] bca, 
                           NxtBrick br,
                           NxtMotor ma,
                           NxtMotor mb,
                           NxtMotor mc,
                           NxtSoundSensor sndS,
                           NxtPressureSensor ps)
        {
             blokcodeArray = bca;
             nxtMA = ma;
             nxtMB = mb;
             nxtMC = mc;
             myBrick = br;
             nxtSndS = sndS;
             nxtPs = ps;
            // transT = new Thread(new ParameterizedThreadStart());
            
        }

        /* 
         * pre:  line is not null
         * post: local bools set
         */
        public void transform()
        {
            test = "TRANSFORM ";
                int lastCodeIndex = endOfBlokCode();
                if (!validateStartTag(blokcodeArray[0, 0, 0]) || blokcodeArray == null)
                {
                    test = "A";
                    MessageBox.Show("De blokcode begint niet met het blokje Begin!");
                }
                else if (!validateEndTag(blokcodeArray[lastCodeIndex -1, 0, 0]))
                {
                    test = "B";
                    MessageBox.Show("De blokcode eindigt niet met het blokje Einde!");
                }
                else
                {
                    int i = 0;
                    test = "VALIDATION OK";
                    while (!String.Equals(blokcodeArray[i, 0, 0], "eof")) //  
                    {
                        //int maxLineIndex = endOfLine(blokcodeArray, i, 0);
                        test += "IN LOOP" + Environment.NewLine;
                        switch (blokcodeArray[i, 0, 0])
                        {
                            case "Lopen":
                                {
                                    test = blokcodeArray[i, 0, 0];
                                    int speed = int.Parse(blokcodeArray[i, 3, 0]);
                                    int stappen = int.Parse(blokcodeArray[i, 2, 0]);
                                    string richting = blokcodeArray[i, 1, 0];
                                    int degrees = 0;
                                    rc.lopen(nxtMB, nxtMC, speed, stappen, degrees, richting);

                                    break;
                                }

                            case "Praten":
                                {

                                    break;
                                }

                            case "Arm/Hoofd":
                                {
                                    test += "bewg Armen" + Environment.NewLine;
                                    int speed = int.Parse(blokcodeArray[i, 2, 0]);
                                    int stappen = int.Parse(blokcodeArray[i, 1, 0]);
                                    rc.beweegArmen(nxtMA, speed, stappen);
                                    break;
                                }
                             case "Als..Dan":
                                 {
                                     rc.lopen(nxtMB, nxtMC, 80, 5, 0, "");
                                     /*//transT.Abort();
                                      //Thread.Sleep(10000);
                                      //transT.Start();
                                      test += "IFELSE";
                                      //i++;//naar de volgende regel
                                      string statement = blokcodeArray[i, 1, 0].Substring(blokcodeArray[i, 1].IndexOf('('), (blokcodeArray[i, 1].IndexOf(')') - blokcodeArray[i, 1].IndexOf('(')));
                                      string[] param = statement.Split('>');
                                      string sensorType = param[0];
                                      int threshold = int.Parse(param[1]);
                                      int beginOfAction = blokcodeArray[i,1].IndexOf(',');
                                      string actionString = blokcodeArray[i,1].Substring(beginOfAction + 1, blokcodeArray[i, 1].Length - (beginOfAction + 1));
                                      string actionType = actionString.Substring(0,actionString.IndexOf('(')-1);
                                      string parameters = actionString.Substring(actionString.IndexOf('('), actionString.IndexOf(')') - actionString.IndexOf('('));                                     
                                      string[] actionParameters = parameters.Split(',');
                                    
                                      if (sensorType.Equals("Geluid"))
                                      {
                                          //int threshold = int.Parse(blokcodeArray[i, 2]);

                                          test += rc.isSound(nxtSndS) + "" + Environment.NewLine;
                                          Thread.Sleep(1000);
                                          if ((lightVal > threshold))
                                          {
                                              switch (actionType)
                                              {
                                                  case "Lopen":
                                                      {

                                                          int speed = int.Parse(actionParameters[2]);
                                                          int stappen = int.Parse(actionParameters[1]);
                                                          string richting = actionParameters[0];
                                                          int degrees = 0;
                                                          rc.lopen(nxtMB, nxtMC, speed, stappen, degrees, richting);
                                                          break;
                                                      }
                                                  case "Arm/Hoofd":
                                                      {
                                                          int speed = int.Parse(actionParameters[2]);
                                                          int stappen = int.Parse(actionParameters[1]);
                                                          rc.beweegArmen(nxtMA, speed, stappen);
                                                          break;

                                                      }
                                              }
                                          }
                                          else
                                          {
                                              i++;
                                              test += rc.isSound(nxtSndS) + "" + Environment.NewLine;
                                              actionString = blokcodeArray[i,1].Substring(blokcodeArray[i,1].IndexOf(','), (blokcodeArray[i,1].IndexOf(';') - blokcodeArray[i,1].IndexOf(',')));
                                              parameters = actionString.Substring(actionString.IndexOf('('), (actionString.IndexOf(')') - actionString.IndexOf('(')));
                                              actionType = actionString.Substring(0, actionString.IndexOf('(') - 1);
                                              actionParameters = parameters.Split(',');

                                              switch (actionType)
                                              {
                                                  case "Lopen":
                                                      {
                                                          int speed = int.Parse(actionParameters[2]);
                                                          int stappen = int.Parse(actionParameters[1]);
                                                          string richting = actionParameters[0];
                                                          int degrees = 0;
                                                          rc.lopen(nxtMB, nxtMC, speed, stappen, degrees, richting);
                                                          break;
                                                      }
                                                  case "Arm/Hoofd":
                                                      {
                                                          int speed = int.Parse(actionParameters[2]);
                                                          int stappen = int.Parse(actionParameters[1]);
                                                          rc.beweegArmen(nxtMA, speed, stappen);
                                                          break;

                                                      }
                                              }
                                          }
                                
                                  }*/
                                     break;
                         }
                      }
                  i++;
                }
            }
        }
        
        
        public void parseSensorActio(string sensorAction)
        {

        }

        /*public string dynamicIfElse(string[,] blokCode, int index)
        {
            string returnAction = "";

            switch (sensor)
            {
                case "sound":
                    {
                        if (rc.isSound(nxtSndS) > thresholdValue)
                        {
                        }

                    }
            }

            return returnAction;
        }*/

        public int endOfBlokCode()
        {
            int maxVerticalIndex = 0;
            for (int i = 0; i < blokcodeArray.Length; i++)     // je zou ook de public const maxRijen kunnen gebruiken, voor consistency
            {
                if (blokcodeArray[i, 0, 0].Equals("eof"))
                {
                    maxVerticalIndex = i;
                    break;
                }
            }
            return maxVerticalIndex;
        }

        
        public int endOfLine(string[,] line, int currentIndex)
        {
            int maxHorizontalIndex = 0;
            for (int i = 0; i < line.Length; i++)
            {
                if (line[currentIndex, i].Equals(EOL))
                {
                    maxHorizontalIndex = i;
                    break;
                }
            }
            return maxHorizontalIndex;
        }

        public bool validateStartTag(string startTag)
        {
             return startTag.Equals(BEGINTAG);
        }

        public bool validateEndTag(string endTag)
        {
            return endTag.Equals(ENDTAG);
        }

        public void terminate()
        {
            rc.terminate(nxtMA,nxtMB, nxtMC);
        }

        public void disConnect()
        {
            rc.disConnect(myBrick);
        }

        /*
         * Robot functies worden hier gedefinieerd
         * 
         * 
         * */

       
    }
}
